
#include "bsp.h"
#include "mrfi.h"
#include "nwk_types.h"
#include "nwk_api.h"
#include "nwk_frame.h"
#include "nwk.h"
#include "bsp_leds.h"
#include "bsp_buttons.h"

#include "app_remap_led.h"


//Prototypes
void toggleLED(uint8_t);
void startTimerA();
void resetTime();
void sendTouched();
void sendNonValid();
static uint8_t sCB(linkID_t);
void configurePorts();
static void linkTo(void);


static uint8_t state = 0;
static linkID_t sLinkID1 = 0;
static uint8_t tics3 = 0;
static uint8_t tics2 = 0;
static uint8_t tics = 0;
//static uint8_t fencer;


//static uint8_t errors = 0;
//static uint8_t packets = 0;
//static uint8_t packets2 = 0;

static uint8_t msg_send[4];

static uint8_t enviar=0;
//static uint8_t flag=0;
static addr_t lAddrAux;

//static uint8_t capture = 0;
//uint8_t pedro=0;
//INs
#define TIP BIT2
#define TIP2 BIT0
#define JACKET BIT1

//Tipe of touch
#define VALID 1
#define NONVALID 2

//States
#define JOINING 1
#define WAITING 2
#define SENDING 3
//#define NONVALIDTOUCH 4


#define SPIN_ABOUT_A_SECOND   NWK_DELAY(1000)
#define SPIN_ABOUT_A_QUARTER_SECOND   NWK_DELAY(250)

#define MILISEC_TIC 1				//from 1 to 4000 ms
#define CICLES_TIC 1000*MILISEC_TIC 

#define TEST_DELAY 1

/* How many times to try a Tx and miss an acknowledge before doing a scan */
#define MISSES_IN_A_ROW  100

void main (void)
{
  BSP_Init();
  BSP_ENABLE_INTERRUPTS();



  addr_t lAddr={0x79,0x56,0x34,0x12};   
  SMPL_Ioctl(IOCTL_OBJ_ADDR, IOCTL_ACT_SET, &lAddr);



  state = JOINING; 
  

  
  while (SMPL_SUCCESS != SMPL_Init(sCB))
  {
    toggleLED(1);
    toggleLED(2);
    SPIN_ABOUT_A_SECOND;
  }

  /* LEDs on solid to indicate successful join. */
  if (!BSP_LED2_IS_ON()) toggleLED(2);
  if (!BSP_LED1_IS_ON()) toggleLED(1);
  

  /* Unconditional link to AP which is listening due to successful join. */
  linkTo();

  while (1); //Unreachable statement
}

static void linkTo()
{
  /*Preparing the end device to listen the AP too*/
  SMPL_Ioctl( IOCTL_OBJ_RADIO, IOCTL_ACT_RADIO_RXON, 0);

  /* Keep trying to link... */
  while (SMPL_SUCCESS != SMPL_Link(&sLinkID1))
  {
    toggleLED(1);
    toggleLED(2);
    SPIN_ABOUT_A_SECOND;
  }

  /* Turn off LEDs. */
  if (BSP_LED2_IS_ON()) toggleLED(2);
  
  if (BSP_LED1_IS_ON()) toggleLED(1);
 
 
 

  

  while (1)
  {
  
  	configurePorts();
  	
  	for(;;){
  		LPM1;
  	}
  }
}

void sendTouched(){
	  
	  //uint8_t     done, misses;
      //smplStatus_t rc;
      //uint8_t     msg[4];

      /* Building the message to send */
      msg_send[3] = tics3;
      msg_send[2] = tics2;
      msg_send[1] = tics;
      msg_send[0] = VALID;
      //done = 0;
      /*while (1)
      {

        
          if (SMPL_SUCCESS == SMPL_SendOpt(sLinkID1, msg, sizeof(msg),SMPL_TXOPTION_NONE))
          {
            
            //toggleLED(1);
            //packets2++;
            //if(packets2 == 0) packets++;/////////////////////////////////////////////////////////////////
            //done=1;
            BSP_TOGGLE_LED1();
            break;
          }
          errors++;
          
        
        
	  }*/
	  state=SENDING;
	  enviar=1;
}

void sendNonValid(){
	
	  //uint8_t      done, misses;
      //smplStatus_t rc;
      

      

      /* Building the message to send */
      msg_send[3] = 0;
      msg_send[2] = 0;
      msg_send[1] = 0;
      msg_send[0] = NONVALID;
      //done = 0;
      /*while (!done)
      {
        

        
        for (misses=0; misses < MISSES_IN_A_ROW; ++misses)
        {
          if (SMPL_SUCCESS == SMPL_Send(sLinkID1, msg, sizeof(msg)))
          {
            
            //toggleLED(1);
            //startTimerA();
            
            
            done=1;
            break;
          }
          
        }
        
	  }*/
	  state=SENDING;
	  enviar=1;
}



void toggleLED(uint8_t which)
{
  if (1 == which)
  {
    BSP_TOGGLE_LED1();
  }
  else if (2 == which)
  {
    BSP_TOGGLE_LED2();
  }
  return;
}


static uint8_t sCB(linkID_t lid)
{
	uint8_t     *msg=NULL;
	uint8_t		len;
	
	
	if (state == JOINING){
		//if (SMPL_SUCCESS == SMPL_Receive(SMPL_LINKID_USER_UUD/*lid*/, msg, &len))
	    //{	  
	    	state = WAITING;
	    	return 0;
	    //}
	}
	
	else if(state!=JOINING && lid==SMPL_LINKID_USER_UUD){
		SMPL_Receive(SMPL_LINKID_USER_UUD, msg, &len);
		if(msg[0]==0){
			
			
			
			
			tics3=0;
			tics2++;
			
			
			
			if (tics2==50) {
				tics2=0;
				tics++;
				//flag=1;
				/*if(lAddrAux.addr[0]==0x80){
					sendTouched();
				}
				else{
					flag=1;
				}*/
				
/*#ifdef TEST_DELAY				
				//addr_t lAddrAux;   
  				SMPL_Ioctl(IOCTL_OBJ_ADDR, IOCTL_ACT_GET, &lAddrAux);
  				if(lAddrAux.addr[0]==0x80) NWK_DELAY(TEST_DELAY);
				sendTouched();
				BSP_TOGGLE_LED1();
#endif	*/			    //////////////////////////////
			}
			P2OUT ^=BIT3;
			startTimerA();
			//BSP_TOGGLE_LED1();
		}
		else if(msg[0]==1){
			tics3=0;
			tics2=0;
			tics=0;
			//P2OUT ^=BIT3;
			startTimerA();
			if (BSP_LED1_IS_ON()) BSP_TOGGLE_LED1();
		}
		
		return 0;
	}
	
	else if (state == WAITING){
	
		
		
		return 0;
	
	}
	
	/*else if (state == TOUCHED || state == NONVALIDTOUCH){
		SMPL_Receive(SMPL_LINKID_USER_UUD, msg, &len);
		if(msg[0]==1){
		
			//capture=TAR;
			state=WAITING;
			//capture=0;
			resetTime();
			
		}
		else if(msg[0]==0){
			tics3=0;
			tics2++;
			startTimerA();
			BSP_TOGGLE_LED1();
		}
		return 0;
	}*/
	
	
	return 0;
}

void startTimerA(){
	
	TACCR0 = CICLES_TIC; // Upper limit of count for TAR
	TACCTL0 = CCIE; // Enable interrupts on Compare 0
	TACTL = MC_1|ID_3|TASSEL_2|TACLR; // Set up and start Timer A
	// "Up to CCR0" mode , divide clock by 8, clock from SMCLK , clear timer
	//__enable_interrupt();
	
	/*
	
	
	BCSCTL3 |= LFXT1S_2;                      // LFXT1 = VLO
  	TACCTL0 = CCIE;                           // TACCR0 interrupt enabled
  	TACCR0 = CICLES_TIC;                           // ~ 40ms
  	TACTL = TASSEL_1 | MC_1 | TACLR;                  // ACLK, upmode
  	
  	*/
  	
  	
  	
  	
  	
}
/*
void resetTime(){
	
	if (BSP_LED2_IS_ON()) toggleLED(2);
  
  	if (BSP_LED1_IS_ON()) toggleLED(1);
  	
	tics2=0;
	tics3=0;
	startTimerA();
}*/

void configurePorts(){
	//P1DIR = BIT2
  	P1IE = TIP;
  	P1IES = TIP;
  	//P2DIR &= ~JACKET;
  	//P2DIR &= ~TIP2;
  	P2REN |= JACKET | TIP2;
  	P2OUT |= JACKET | TIP2;
  	P2IE |= JACKET;
  	P2IES |= JACKET;
  	
  	
  	P2DIR |=BIT3;
}

#pragma vector = TIMERA0_VECTOR
__interrupt void TIMERA0_ISR (void) // ISR for TACCR1 CCIFG and TAIFG
{
	
	tics3++;
	/*if(flag == 1 && tics3==TEST_DELAY){////////////////////////////////////
		sendTouched();
		//BSP_TOGGLE_LED1();
		flag=0;
	}*/
	
	if(enviar==1){			   
  		SMPL_Ioctl(IOCTL_OBJ_ADDR, IOCTL_ACT_GET, &lAddrAux);
  		if(lAddrAux.addr[0]==0x80) {
  			if(tics3%4==0){
  	  			SMPL_Send(sLinkID1, msg_send, sizeof(msg_send));
  	  			BSP_TOGGLE_LED1();
  	  			enviar=0;
				state=WAITING;
  			}
  		}
  		else {
  			if(tics3%4==2){
  	  			SMPL_Send(sLinkID1, msg_send, sizeof(msg_send));
  	  			BSP_TOGGLE_LED1();
  	  			enviar=0;
				state=WAITING;
  			}		
  		}
  				
			
			
	}
	
	
	
	
	P2OUT ^=BIT3;
			
}
	
#pragma vector = PORT1_VECTOR
__interrupt void PORT1_ISR (void)
{
	//SMPL_Ioctl( IOCTL_OBJ_RADIO, IOCTL_ACT_RADIO_AWAKE, 0);
	
	if(!(P1IN & TIP) && state==WAITING){
	
		//SPIN_ABOUT_A_QUARTER_SECOND;
		
		if((P2IN & TIP2) && state==WAITING){
			sendNonValid();
			//state=NONVALIDTOUCH;
		}
		/*else{
			P2IFG &= ~TIP2;
		}*/
		
		//P1IFG = 0;
	}
	
	
		
	do {
		P1IFG = 0; // Clear any pending interrupts ...
	} while (P1IFG != 0);
	
	//SMPL_Ioctl( IOCTL_OBJ_RADIO, IOCTL_ACT_RADIO_SLEEP, 0);
}



//#pragma vector = PORT2_VECTOR
//__interrupt void PORT2_ISR (void)
BSP_ISR_FUNCTION( BSP_GpioPort1Isr, PORT2_VECTOR )
{
	
	
	if(P2IFG & JACKET){
  	//He sido tocado valido.
  	
  		//SPIN_ABOUT_A_QUARTER_SECOND;
  		if(state==WAITING) {
  			//SMPL_Ioctl( IOCTL_OBJ_RADIO, IOCTL_ACT_RADIO_AWAKE, 0);
  			sendTouched();
  			//SMPL_Ioctl( IOCTL_OBJ_RADIO, IOCTL_ACT_RADIO_SLEEP, 0);
			//state=TOUCHED;
  		}
		
		P2IFG &= ~JACKET;
	}
		
   
	MRFI_GpioIsr();
	
	
	
}


